from fastapi import APIRouter, Request, Response
from jsonrpcserver import (
    dispatch as _dispatch,
    method as rpc,
    Result,
    Success,
    Error,
    InvalidParams,
)


_dispatcher = APIRouter()


@_dispatcher.post(path='/', name='RPC', description='Remote procedure call')
async def _rpc(request: Request):
    """JSON RPC 2.0 Dispatcher."""
    return Response(_dispatch(await request.body()))


def get_rpc_dispatcher() -> APIRouter:
    """Get rpc dispatcher."""
    return _dispatcher


__all__ = (
    'get_rpc_dispatcher',
    'rpc',
    'Result',
    'Success',
    'Error',
    'InvalidParams',
)
